//<#!@READ-ONLY-SECTION-START@!#>
/*!
 * \class cfm_function
 * \brief Intel(R) CoFluent(TM) Studio - Intel Corporation
 * \details Simulation model of AIC_MU_ProjectApp generated by C++ Generator for SystemC/TLM2
 */

#ifndef COFS_MODEL_AIC_MU_PROJECTAPP_FUNCTION
#define COFS_MODEL_AIC_MU_PROJECTAPP_FUNCTION

#include "cfm_aic_mu_projectapp_global.h"
#include "cfm_aic_mu_projectapp_global_types.h"
#include "cofluent.h"

//<#!@READ-ONLY-SECTION-END@!#>
//Start of 'Function includes' algorithm generated code

//End of 'Function includes' algorithm generated code
//<#!@READ-ONLY-SECTION-START@!#>

///    \defgroup dxgFunction Function Function
//@{
///        \page dxpFunction
//@{
///    \brief Function function model.
class cfm_function: public cf_core::cf_function {
public:

	/// ports typedef
	typedef cf_core::cf_mq_initiator_socket<cfm_function,
			cf_core::cf_payload_int> p_mq_MsgQ_t;

	/// constructor
	cfm_function(sc_core::sc_module_name name);

	/// destructor
	virtual ~cfm_function(void);
	virtual void cb_before_elaboration(void);

public:
	/// \name input/output ports
	//@{
	p_mq_MsgQ_t p_mq_MsgQ;
	//@}

protected:
	/// initialize attributes
	void cb_init_attributes(void);
	/// initialize definitions
	void cb_init_local_vars(void);

	/// \name user-defined local declarations
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'Function local declarations' algorithm generated code

	//End of 'Function local declarations' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>

};

//@}
//@}
#endif // COFS_MODEL_AIC_MU_PROJECTAPP_FUNCTION

//<#!@READ-ONLY-SECTION-END@!#>